/* pcibios.h */

#define REAL_MODE   0
#define PROT16_MODE 1
#define PROT32_MODE 2

/* Configuration Space Header Offsets */
#define OFF_VENDOR_ID   0x00
#define OFF_DEVICE_ID   0x02
#define OFF_COMMAND    0x04
#define OFF_STATUS     0x06
#define OFF_REVISION_ID 0x08
#define OFF_PROG_IN    0x09
#define OFF_SUB_CLASS   0x0a
#define OFF_BASE_CLASS  0x0b
#define OFF_CACHELS    0x0c
#define OFF_LATTIMER    0x0d
#define OFF_HEADERTYPE  0x0e
#define OFF_BIST          0x0f

#define OFF_BASE_ADDR   0x10
#define PLX9030_OFF_BASE_ADDR   0x18
#define OFF_INT_LINE    0x3C

//#define OFF_PERIODIC_INT 0x40

/************************** bios functions *******************/
int pci_init(void);
int pci_get_status(int *major_version,
				   int *minor_version,
				   int *last_bus,
				   int *access_flags);
int pci_find_device(int DevId,
					int VenId,
					int Index,
					int *bus_number,
					int *function_number,
					int *device_number);
int pci_read_word(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  WORD *config_reg);
int pci_read_byte(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  BYTE *config_reg);

#ifdef UNUSED_FUNCS
int pci_read_dword(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  DWORD *config_reg);
int pci_write_dword(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  DWORD config_reg);
int pci_write_word(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  WORD config_reg);
int pci_write_byte(int BusNum,
				  int DevNum,
				  int FuncNum,
				  int RegNum,
				  BYTE config_reg);
#endif
