;--------------------------------------------------------------------------
; rckti14.asm - fossil int14 entry point.

;  1-30-97 - Make so TSR can unload.
;  2-10-96 - Optimize some assembly for speed - kpb.
; 11-01-95 -
;   make reentrant for multitasking environment - kpb.
;
; 10-21-95 -
;  Original driver would not co-exist with previously loaded fossil driver.
;  Adjust so as to work properly. - kpb.
;
; Copyright 1996 Comtrol Corporation.  All rights reserved.  Proprietary
; information not permitted for development or use with non-Comtrol products.
;--------------------------------------------------------------------------
.286
;.MODEL tiny
;.CODE

  extrn _main:near
  extrn _data_seg:word
  extrn _comFirst:word
  extrn _comLast:word
  extrn _driver_mode:word
  extrn _OldIsr14:far
  extrn _OldIsr8:far
  extrn _AppHook:far
  extrn _RCKTInt:near
  extrn _RCKTInt8:near
  extrn _RCKTInt14:near

ifdef DOS_NAMES
  extrn _strat_c:near
  extrn _intr_c:near
endif

  extrn _loaded_stat:word

DGROUP	group	_TEXT,_DATA,_BSS,_ENDBSS
	assume	ds:DGROUP
_TEXT segment word public 'CODE'
_TEXT ends
_DATA	segment word public 'DATA'
_DATA	ends
_BSS	segment word public 'BSS'
_BSS	ends
_ENDBSS	segment word public 'ENDBSS'
_ENDBSS	ends


_ENDBSS	segment word public 'ENDBSS'
vend           db 1 dup (55H)
_ENDBSS	ends

_DATA	segment word public 'DATA'
	assume	ds:DGROUP

; translation table to determine type of call, where
; 0 = function which we don't service.
; 1 = comm function using DX as index of com-port we service.
; 2 = non-comm function which we service.
;              0,1,2,3,4, 5,6,7,8,9,a,b,c,d,e,f
is_comm_tbl db 1,1,1,1,1, 1,1,2,1,1,1,1,1,2,2,1  ; 7-tmr c,d=keybd
            db 2,2,2,2,2, 2,2,2,1,1,1,2,1,1,1,1  ;
            db 1,1,0,0,0;

_DATA	ends

public _RCKTIsr14
public _RCKTIsr8
public _RCKTIsr

ifdef DOS_NAMES
_named_dev db 128 dup (?)
 public _named_dev
 public _RCKT_Strat
 public _RCKT_Intr
endif

_TEXT	segment word public 'CODE'
              assume cs:_TEXT, ds:DGROUP

              org 100h
begin:        jmp initialize             ;goto initialization routine

;---------------------------------------------------------------------------
; _RCKTIsr14 - Int14 Entry, FOSSIL and INT14 serial BIOS services
;---------------------------------------------------------------------------
_RCKTIsr14  proc far
  jmp  Isr14_00    ; jump around the signature

  org  _RCKTIsr14+6    ; offset 6 gets a
  dw  1954H      ; special signature and
  db  21H      ; maximum function number supported
  db  'Rocket',0    ; want a Comtrol RocketPort ID

Isr14_00:

  push  ds  ; save DS coming in
  push  cs
  pop   ds  ; ds = cs

;---- check DX port value for validity(is it ours?)
chk_port_range:
  cmp  dx,_comFirst      ;device below range?
  jl   def_int0          ;on to other checks

  cmp  dx,_comLast       ;device above range?
  jg   def_int0          ;on to other checks

;---- our int14 fossil driver entry point.
;---- might want to change the following to a pusha/popa combo
our_service:

  ; Our c-routine figures gets passed a pointer to our pusha data on stack
  ; and modifies it directly for return values.
  ; So create a structure on the stack and pass it in to our handler
  pusha            ; push 8-words(17clks) AX,CX,DX,BX, SP,BP,SI,DI
  push  es         ; catch ES too
  pushf            ; catch flags, digi-bios sucks(uses flags on ret)
  sub sp, 2        ; 1-word(use as space for Port *)
;  push  ax         ; push 1-word(use as space for Port *)

  push  ss ; push 1st parm: far * to our struct
  push  sp ; push 1st parm: far * to our struct
  call  _RCKTInt14 ; push ret-addr

  add   sp, 6 ; throw away first 3 parameters on stack.
;  pop   ax ; junk(sp)
;  pop   ax ; junk(ss)
;  pop   ax ; junk(ax) Port *
  popf     ; set flags
  pop   es ;
  popa     ; pop reg values out of caller struct with modifications

  pop  ds
  iret

def_int0:
  push  bx
  push  ax

  mov     bx, _driver_mode   ; are we in fossil mode?
  test    bx, 1
  jnz     def_int2           ; no, so get out(dx not set to our port)

def_int1:
  cmp     ah,21H             ; over max function
  ja      def_int2           ; skip it, function out of range
  ;----- now check lookup table for non-comm(dx not a port index) type func.
  lea bx, is_comm_tbl        ; bx = array for xlat lookup
  xchg    ah,al              ; make al = function index
  xlat                       ; al = is_comm_tbl[al]
  ;----- al, 0=not_our_func 1=_our_port_func, 2=our_non_port_func
  test    al,2               ; see if possible fossil non port func
  jz   bad_range             ; else ok, ours
  pop     ax
  pop     bx
  jmp  our_service           ; ours, fossil, non-comm. specific

  ;---- return error, bad range
bad_range:
;  pop     ax
;  mov     ax, 0  ; (no default error value for fossil) use 0.
;  pop     bx
;  pop     ds
;  iret
  
  ;---- jmp to original int14 handler(could be another fossil)
def_int2:
  pop     ax
  pop     bx
  pop     ds
  jmp  cs:dword ptr _OldIsr14  ; take the old handler, gone for good

_RCKTIsr14  endp

ifdef DOS_NAMES
;---------------------------------------------------------------------------
;_RCKT_Strat - Strategy Routine, part of DOS named device driver.
;---------------------------------------------------------------------------
_RCKT_Strat  proc near
     push ds
     push es
     pusha

;;     push cs
;;     pop ds  ; ds = cs
     mov ax, DGROUP
     mov ds, ax

     push es ; pass es:bx pointer to request header
     push bx ;
   call  _strat_c
     pop   ax ; junk(ex)
     pop   ax ; junk(bx)

     popa
     pop es
     pop ds
     ret
_RCKT_Strat  endp

;---------------------------------------------------------------------------
;_RCKT_Intr - Interrupt Routine, part of DOS named device driver.
;---------------------------------------------------------------------------
_RCKT_Intr  proc near
     push ds
     push es
     pusha

;     push cs
;     pop ds  ; ds = cs

     mov ax, DGROUP
     mov ds, ax

   call  _intr_c
     popa
     pop es
     pop ds
     ret
_RCKT_Intr  endp
endif

;---------------------------------------------------------------------------
;_RCKTIsr8 - Timer Interrupt routine.
;---------------------------------------------------------------------------
_RCKTIsr8  proc far
;     sti                                ;enable interrupts

     push ds
     push es
     pusha

     push cs
     pop ds  ; ds = cs

     call  _RCKTInt8

     ;----  check and call our application hook
     mov   ax,word ptr _AppHook
     or    ax,word ptr _AppHook+2
     je    short noapp1
     call  dword ptr _AppHook;
noapp1:

     popa
     pop es
     pop ds

     jmp  cs:dword ptr _OldIsr8  ; take the old handler, gone for good

;     pushf
;     call  cs:dword ptr _OldIsr8  ; take the old handler, gone for good
;     iret
_RCKTIsr8  endp                               ;end of main body of program

;---------------------------------------------------------------------------
;_RCKTIsr - Hardware Interrupt routine.
;---------------------------------------------------------------------------
_RCKTIsr  proc far
     sti                                ;enable interrupts

     push ds
     push es
     pusha

     push cs
     pop ds  ; ds = cs

     call  _RCKTInt

     ;----  check and call our application hook
     mov   ax,word ptr _AppHook
     or    ax,word ptr _AppHook+2
     je    short noapp2
     call  dword ptr _AppHook;
noapp2:

     popa
     pop es
     pop ds

     iret
_RCKTIsr  endp                               ;end of main body of program

;---------------------------------------------------------------------------
; initialize -
;---------------------------------------------------------------------------
initialize    proc near
              assume ds:DGROUP

              mov ax, 80H  ; point to command tail
              push ax
              call    _main
              pop cx
              cmp ax, 0
              jne  bail
              mov dx,offset cs:vend       ;point dx to end of resident section
              int 27h                            ;terminate-but-stay-resident
bail:
              MOV     AH,4CH  ; terminate process
              INT     21H  ; normal dos exit
initialize    endp


;---------------------------------------------------------------------------
; N_LXURSH -
;---------------------------------------------------------------------------
public N_LXURSH@, LXURSH@, F_LXURSH@
N_LXURSH@  proc
		pop	BX
		push	CS
		push	BX
LXURSH@:
F_LXURSH@:
		cmp	CL,010h
		jae	LR18
		mov	BX,DX
		shr	AX,CL
		shr	DX,CL
		neg	CL
		add	CL,010h
		shl	BX,CL
		or	AX,BX
		retf
LR18:		sub	CL,010h
		xchg	AX,DX
		xor	DX,DX
		shr	AX,CL
		retf
N_LXURSH@ endp

;---------------------------------------------------------------------------
; N_LXLSH -
;---------------------------------------------------------------------------
public N_LXLSH@, F_LXLSH@, LXLSH@
N_LXLSH@ proc
		pop	BX
		push	CS
		push	BX
LXLSH@:
F_LXLSH@:
		cmp	CL,010h
		jae	L18
		mov	BX,AX
		shl	AX,CL
		shl	DX,CL
		neg	CL
		add	CL,010h
		shr	BX,CL
		or	DX,BX
		retf
L18:		sub	CL,010h
		xchg	AX,DX
		xor	AX,AX
		shl	DX,CL
		retf
N_LXLSH@ endp

public F_LXMUL@
public N_LXMUL@
;---------------------------------------------------------------------------
; N_LXMUL@ -
;---------------------------------------------------------------------------
F_LXMUL@:
N_LXMUL@ proc
		push	SI
		xchg	AX,SI
		xchg	AX,DX
		test	AX,AX
		je	L9
		mul	BX
L9:		jcxz	L10
		xchg	AX,CX
		mul	SI
		add	AX,CX
L10:		xchg	AX,SI
		mul	BX
		add	DX,SI
		pop	SI
		ret
N_LXMUL@  endp

public	LUMOD@,LDIV@,F_LUMOD@,N_LUMOD@
public	N_LMOD@,F_LMOD@,LMOD@,N_LUDIV@
public	F_LUDIV@,LUDIV@,N_LDIV@,F_LDIV@
;---------------------------------------------------------------------------
; N_LDIV
;---------------------------------------------------------------------------
N_LDIV@ proc
		pop	CX
		push	CS
		push	CX
LDIV@:
F_LDIV@:
		xor	CX,CX
		jmp short	L1D
N_LUDIV@:
		pop	CX
		push	CS
		push	CX
F_LUDIV@:
LUDIV@:
		mov	CX,1
		jmp short	L1D
N_LMOD@:
		pop	CX
		push	CS
		push	CX
F_LMOD@:
LMOD@:
		mov	CX,2
		jmp short	L1D
N_LUMOD@:
		pop	CX
		push	CS
		push	CX
LUMOD@:
F_LUMOD@:
		mov	CX,3
L1D:		push	BP
		push	SI
		push	DI
		mov	BP,SP
		mov	DI,CX
		mov	AX,0Ah[BP]
		mov	DX,0Ch[BP]
		mov	BX,0Eh[BP]
		mov	CX,010h[BP]
		or	CX,CX
		jne	L3C
		or	DX,DX
		je	LA1
		or	BX,BX
		je	LA1
L3C:		test	DI,1
		jne	L5E
		or	DX,DX
		jns	L50
		neg	DX
		neg	AX
		sbb	DX,0
		or	DI,0Ch
L50:		or	CX,CX
		jns	L5E
		neg	CX
		neg	BX
		sbb	CX,0
		xor	DI,4
L5E:		mov	BP,CX
		mov	CX,020h
		push	DI
		xor	DI,DI
		xor	SI,SI
L68:		shl	AX,1
		rcl	DX,1
		rcl	SI,1
		rcl	DI,1
		cmp	DI,BP
		jb	L7F
		ja	L7A
		cmp	SI,BX
		jb	L7F
L7A:		sub	SI,BX
		sbb	DI,BP
		inc	AX
L7F:		loop	L68
		pop	BX
		test	BX,2
		je	L8E
		mov	AX,SI
		mov	DX,DI
		shr	BX,1
L8E:		test	BX,4
		je	L9B
		neg	DX
		neg	AX
		sbb	DX,0
L9B:		pop	DI
		pop	SI
		pop	BP
		retf	8
LA1:		div	BX
		test	DI,2
		je	LAA
		xchg	AX,DX
LAA:		xor	DX,DX
		jmp short	L9B
N_LDIV@  endp


_TEXT         ends
              end begin


